/*  
 *  hello.c 
 */
#include <linux/module.h>	
#include <linux/kernel.h>	/* KERN_INFO */
#include <linux/init.h>		/* macros */

#define DRIVER_AUTHOR "Grande Puffo"
#define DRIVER_DESC   "Sample Module"

/* Declare code as GPL. */
MODULE_LICENSE("GPL");

MODULE_AUTHOR(DRIVER_AUTHOR);	
MODULE_DESCRIPTION(DRIVER_DESC);

static int __init init_hello(void)
{
	printk(KERN_INFO "Hello, world\n");
	return 0;
}

static void __exit cleanup_hello(void)
{
	printk(KERN_INFO "Goodbye, world\n");
}

module_init(init_hello); 
module_exit(cleanup_hello); 

/*  or define
void init_module(void)
{
....
}

void cleanup_module(void)
{
...
}
*/

